# -*- encoding: utf-8 -*-
#
#  company.py
#  l10n_ch
#
#  Created by Nicolas Bessi based on Credric Krier contribution
#
#  Copyright (c) 2009 CamptoCamp. All rights reserved.
##############################################################################
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import netsvc
from osv import fields, osv
class res_company(osv.osv):
    """override company to add product price computation"""
    
    _inherit = "res.company"
    
    def button_refresh_price_computation(self, cr, uid, ids, context=None):
        """Refrech  the currency !!for all the company
        now"""
        xls_updater_obj = self.pool.get('xls.product.calculator')
        try:
            xls_updater_obj.run_product_compute(cr, uid,'manual')
        except Exception, e:
            print str(e)
            return False
        return True
    
    
    def _on_change_auto_product_compute_up(self, cr, uid, id, value):
        """handle the activation of product computation"""
        
        if len(id) :
            id = id[0]
        else :
            return {}
        compagnies =  self.search(cr, uid, [])
        activate_cron = False
        if value :
            activate_cron = True
        for comp in self.browse(cr, uid, compagnies) :
            comp.write({'auto_product_compute_up':value})
        print activate_cron
        self.pool.get('xls.product.calculator').save_cron(
                                                        cr, 
                                                        uid, 
                                                        {'active':activate_cron}
                                                    )
        return {}                
    
    def _on_change_product_computation_intervall(self, cr, uid, id, interval) :
        ###Function that will update the cron
        ###freqeuence
        self.pool.get('xls.product.calculator').save_cron(
                                                            cr, 
                                                            uid, 
                                                            {'interval_type':interval}
                                                        )
        compagnies =  self.search(cr, uid, [])
        for comp in compagnies :
            self.write(cr, uid, comp,{'prod_computation_interval_type':interval})
        return {'value':{'auto_product_compute_up':True}}
        
    _columns = {
        ### activate the currency update
        'auto_product_compute_up': fields.boolean('Automatical update of the currency this company'),
        'prod_computation_interval_type': fields.selection(
                                                [
                                                    ('days','Day(s)'), 
                                                    ('weeks', 'Week(s)'), 
                                                    ('months', 'Month(s)'),
                                                ],
                                                'Currency update frequence',
                                                help="""changing this value will
                                                 also affect other compagnies"""
                                            ),
    }    
res_company()